Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/IsReadyForDataTaking
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/IsReadyForDataTaking	(revision 13718)
+++ 	(revision )
@@ -1,19 +1,0 @@
-# Checking the system statuses if they are ready for data taking
->
-> Checking the system statuses
-> ...checking DRIVE
-# 7 = Tracking
-.s DRIVE_CONTROL 7
-
-> ...checking FEEDBACK
-# 12 = CurrentControl
-.s FEEDBACK 12
-
-> ...checking BIAS
-# 9 = VoltageOn
-.s BIAS_CONTROL 9
-
-> ...checking FAD
-# 4 = Connected
-.s FAD_CONTROL 4
-> ...system statuses OK
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/IsReadyForDataTaking.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/IsReadyForDataTaking.dim	(revision 13719)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/IsReadyForDataTaking.dim	(revision 13719)
@@ -0,0 +1,24 @@
+#!dimctrl --exec
+
+# ==========================================================================
+# Checking the system statuses if they are ready for data taking
+# ==========================================================================
+
+>
+> Checking the system statuses
+> ...checking DRIVE
+# 7 = Tracking
+.s DRIVE_CONTROL 7
+
+> ...checking FEEDBACK
+# 12 = CurrentControl
+.s FEEDBACK 12
+
+> ...checking BIAS
+# 9 = VoltageOn
+.s BIAS_CONTROL 9
+
+> ...checking FAD
+# 4 = Connected
+.s FAD_CONTROL 4
+> ...system statuses OK
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/StopTracking
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/StopTracking	(revision 13718)
+++ 	(revision )
@@ -1,10 +1,0 @@
-# stop drivectrl tracking the current source
->
-> stopping tracking of current wobble position
-.w 2000
-DRIVE_CONTROL/STOP 
-> ...DRIVE: tracking stopped
-
-.s DRIVE_CONTROL 5 
-> ...DRIVE: Armed
-> ...tracking stopped
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/StopTracking.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/StopTracking.dim	(revision 13719)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/StopTracking.dim	(revision 13719)
@@ -0,0 +1,15 @@
+#!dimctrl --exec
+
+# ==========================================================================
+# stop drivectrl tracking the current source
+# ==========================================================================
+
+>
+> stopping tracking of current wobble position
+.w 2000
+DRIVE_CONTROL/STOP
+> ...DRIVE: tracking stopped
+
+.s DRIVE_CONTROL 5
+> ...DRIVE: Armed
+> ...tracking stopped
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TakeDataRun
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TakeDataRun	(revision 13718)
+++ 	(revision )
@@ -1,12 +1,0 @@
-.x ScriptsForDimCtrl/IsReadyForDataTaking
-
-> taking Data:FullTriggerArea 5min Run ...
-MCP/START 300 -1 data
-
-.s FAD_CONTROL 8 
-> ... FAD: Writing
-
-.s FAD_CONTROL 4 
-> ... FAD: connceted
-
-> ... done
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TakeDataRun.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TakeDataRun.dim	(revision 13719)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TakeDataRun.dim	(revision 13719)
@@ -0,0 +1,18 @@
+#!dimctrl --exec
+
+# ==========================================================================
+# Take a 5min Data Run
+# ==========================================================================
+
+.x ScriptsForDimCtrl/IsReadyForDataTaking.dim
+
+> taking Data:FullTriggerArea 5min Run ...
+MCP/START 300 -1 data
+
+.s FAD_CONTROL 8
+> ... FAD: Writing
+
+.s FAD_CONTROL 4
+> ... FAD: connceted
+
+> ... done
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble1
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble1	(revision 13718)
+++ 	(revision )
@@ -1,10 +1,0 @@
-# changing tracking to "Crab" Wobble 1
->
-> moving telescope to wobble position 1
->...waiting for drivectrl to be ready to move
-.s DRIVE_CONTROL 5 
-> DRIVE: ARMED
-.w 5000
-
-DRIVE_CONTROL/TRACK_SOURCE 0.6 50 Crab
->...sent tracking command for Crab Wobble 1
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble1.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble1.dim	(revision 13719)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble1.dim	(revision 13719)
@@ -0,0 +1,15 @@
+#!dimctrl --exec
+
+# ==========================================================================
+# changing tracking to "Crab" Wobble 1
+# ==========================================================================
+
+>
+> moving telescope to wobble position 1
+>...waiting for drivectrl to be ready to move
+.s DRIVE_CONTROL 5
+> DRIVE: ARMED
+.w 5000
+
+DRIVE_CONTROL/TRACK_SOURCE 0.6 50 Crab
+>...sent tracking command for Crab Wobble 1
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble2
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble2	(revision 13718)
+++ 	(revision )
@@ -1,10 +1,0 @@
-# changing tracking to "Crab" Wobble 2
->
-> moving telescope to wobble position 2
->...waiting for drivectrl to be ready to move
-.s DRIVE_CONTROL 5 
-> DRIVE: ARMED
-.w 5000
-
-DRIVE_CONTROL/TRACK_SOURCE 0.6 -130 Crab
->...sent tracking command for Crab Wobble 2
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble2.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble2.dim	(revision 13719)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble2.dim	(revision 13719)
@@ -0,0 +1,15 @@
+#!dimctrl --exec
+
+# ==========================================================================
+# changing tracking to "Crab" Wobble 2
+# ==========================================================================
+
+>
+> moving telescope to wobble position 2
+>...waiting for drivectrl to be ready to move
+.s DRIVE_CONTROL 5
+> DRIVE: ARMED
+.w 5000
+
+DRIVE_CONTROL/TRACK_SOURCE 0.6 -130 Crab
+>...sent tracking command for Crab Wobble 2
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble1
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble1	(revision 13718)
+++ 	(revision )
@@ -1,11 +1,0 @@
-# changing tracking to "Mrk 421" Wobble 1
->
-> moving telescope to wobble position 1
->...waiting for drivectrl to be ready to move
-.s DRIVE_CONTROL 5 
-> DRIVE: ARMED
-.w 5000
-
-DRIVE_CONTROL/TRACK_SOURCE 0.6 90 "Mrk 421" 
->...sent tracking command for Mrk 421 Wobble 1
-
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble1.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble1.dim	(revision 13719)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble1.dim	(revision 13719)
@@ -0,0 +1,16 @@
+#!dimctrl --exec
+
+# ==========================================================================
+# changing tracking to "Mrk 421" Wobble 1
+# ==========================================================================
+
+>
+> moving telescope to wobble position 1
+>...waiting for drivectrl to be ready to move
+.s DRIVE_CONTROL 5
+> DRIVE: ARMED
+.w 5000
+
+DRIVE_CONTROL/TRACK_SOURCE 0.6 90 "Mrk 421"
+>...sent tracking command for Mrk 421 Wobble 1
+
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble2
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble2	(revision 13718)
+++ 	(revision )
@@ -1,10 +1,0 @@
-# changing tracking to "Mrk 421" Wobble 2
->
-> moving telescope to wobble position 2
-> ...waiting for drivectrl to be ready to move
-.s DRIVE_CONTROL 5 
-> ...DRIVE: ARMED
-.w 5000
-
-DRIVE_CONTROL/TRACK_SOURCE 0.6 -90 "Mrk 421" 
->...sent tracking command for Mrk 421 Wobble 2
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble2.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble2.dim	(revision 13719)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble2.dim	(revision 13719)
@@ -0,0 +1,15 @@
+#!dimctrl --exec
+
+# ==========================================================================
+# changing tracking to "Mrk 421" Wobble 2
+# ==========================================================================
+
+>
+> moving telescope to wobble position 2
+> ...waiting for drivectrl to be ready to move
+.s DRIVE_CONTROL 5
+> ...DRIVE: ARMED
+.w 5000
+
+DRIVE_CONTROL/TRACK_SOURCE 0.6 -90 "Mrk 421"
+>...sent tracking command for Mrk 421 Wobble 2
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/WaitForTracking
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/WaitForTracking	(revision 13718)
+++ 	(revision )
@@ -1,14 +1,0 @@
-# Wait for drivectrl to reply that its tracking the given source
-
-# DRIVE: Moving
-> waiting for state moving
-.s DRIVE_CONTROL 6
-> ...moving
-
-# DRIVE: TRACKING
-> waiting for state tracking
-.s DRIVE_CONTROL 7
-> ...tracking requested wobble position
-
-> waiting 30 sec for drive to calm down and tracking beeing stable
-.w 30000
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/WaitForTracking.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/WaitForTracking.dim	(revision 13719)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/WaitForTracking.dim	(revision 13719)
@@ -0,0 +1,18 @@
+#!dimctrl --exec
+
+# ==========================================================================
+# Wait for drivectrl to reply that its tracking the given source
+# ==========================================================================
+
+# DRIVE: Moving
+> waiting for state moving
+.s DRIVE_CONTROL 6
+> ...moving
+
+# DRIVE: TRACKING
+> waiting for state tracking
+.s DRIVE_CONTROL 7
+> ...tracking requested wobble position
+
+> waiting 30 sec for drive to calm down and tracking beeing stable
+.w 30000