Index: trunk/FACT++/www/smartfact/index.css
===================================================================
--- trunk/FACT++/www/smartfact/index.css	(revision 13722)
+++ trunk/FACT++/www/smartfact/index.css	(revision 13747)
@@ -128,6 +128,5 @@
    width: 18px;
    height: 18px;
-   zoom: 1.5;
-   display:table-cell;
+   zoom: 1.;
 }
 
@@ -153,5 +152,5 @@
 */
 .tfoot {
-	background: #737373 url(gradient.png) bottom left repeat-x;
+	background: #737373 url(img/gradient.png) bottom left repeat-x;
 	color: #fff;
 	border-color: #525252;
Index: trunk/FACT++/www/smartfact/index.js
===================================================================
--- trunk/FACT++/www/smartfact/index.js	(revision 13722)
+++ trunk/FACT++/www/smartfact/index.js	(revision 13747)
@@ -373,4 +373,5 @@
     var htd2 = document.createElement("td");
     var htd3 = document.createElement("td");
+    var htd4 = document.createElement("td");
     htd0.setAttribute("class", "tcell1");
     htd1.setAttribute("class", "tcell2");
@@ -379,4 +380,6 @@
     htd3.setAttribute("class", "tcell1");
     htd3.setAttribute("width", "1px");
+    htd4.setAttribute("width", "1px");
+    hhtr.appendChild(htd4);
     hhtr.appendChild(htd3);
     hhtr.appendChild(htd0);
@@ -387,8 +390,12 @@
     var div2 = document.createElement("div");
     var div3 = document.createElement("div");
+    var div4 = document.createElement("div");
+    div4.id = "warn"+z;
     div2.setAttribute("class", "icon_white");
     div3.setAttribute("class", "icon_white");
+    div4.setAttribute("class", "icon_color");
     div2.setAttribute("style", "background-position:-396px 50%;");
     div3.setAttribute("style", "background-position:-575px 50%;");
+    div4.setAttribute("style", "display:none;background-position:-12px -12px;");
     div3.onclick = function() { this.style.backgroundColor='rgba(0,0,0,0.77)'; loadPage('fact', z, -z); }
     div2.onclick = function() { this.style.backgroundColor='rgba(0,0,0,0.77)'; loadPage(fname, z, -dz); }
@@ -407,5 +414,12 @@
     sp2.appendChild(document.createTextNode(" \u2022 "));
     if (title[1]!=undefined)
-        sp1.onclick = function() { submit(title[1]); }
+    {
+        // sp1.onclick = function() { this.style.backgroundColor='rgba(0,0,0,0.77)'; loadPage('fact', z, -1); }
+    }
+    else
+    {
+        if (name!='control')
+            sp1.onclick = function() { this.style.backgroundColor='rgba(0,0,0,0.15)'; loadPage('control', z, +1); }
+    }
 
     div1.setAttribute("style", "font-size:small;");
@@ -422,4 +436,5 @@
     if (lines[0]!="FACT")
         htd3.appendChild(div3); // home
+    htd4.appendChild(div4);     // Warning
 
     // -----------------------------------------------------
@@ -587,5 +602,8 @@
         if (check.length==0 || check[0]!="input")
         {
-            cell1.appendChild(document.createTextNode(cols[1]));
+            var div = document.createElement("div");
+            div.innerHTML = cols[1];
+            cell1.appendChild(div);
+            //cell1.appendChild(document.createTextNode(cols[1]));
 
             if (cols.length>2 && cols[2].length>0)
@@ -606,5 +624,8 @@
                 alert("Argument name missing for'"+check[1]+"'");
 
-            cell1.appendChild(document.createTextNode(opt[0]));
+            var div = document.createElement("div");
+            div.innerHTML = opt[0];
+            cell1.appendChild(div);
+            //cell1.appendChild(document.createTextNode(opt[0]));
 
             var input = document.createElement("input");
@@ -896,14 +917,18 @@
     var date1 = new Date();
 
-    if (tokens[0].length!=13)
+    var header = tokens[0].split('\t');
+
+    // File corrupted /should we remove the date?)
+    if (header.length!=2 && header.length!=1 && header[0].length!=13)
     {
         if (date0 != null)
             strike(time, date0.getTime()+60000>date1.getTime());
-        // FIXME: Reset display to "---" values -- no connection
         return;
     }
 
     var date2 = new Date();
-    date2.setTime(tokens[0]);
+    date2.setTime(header[0]);
+
+    $("warn"+z).style.display = header.length!=2 || header[1]=='1' ? "none" : "";
 
     strike(time, date2.getTime()+60000>date1.getTime());
@@ -1320,6 +1345,4 @@
 }
 
-var gfxtime0 = null;
-
 function process_eventdata(result)
 {
@@ -1338,8 +1361,8 @@
 
     var data = result.split('\n');
-    if (result.length<3)
-        return;
-
-    var l = data[0].length+1+data[1].length+1;
+    if (result.length<4)
+        return;
+
+    var l = data[0].length+1+data[1].length+1+data[2].length+1;
 
     switch (type)
@@ -1347,16 +1370,18 @@
         //case "camera": drawCam(result);     break;
     case "hist":
-        drawGraph(canv, data[0], data[1], result.substr(l));
+        drawGraph(canv, data[1], data[2], result.substr(l));
         break;
     case "camera":
         drawFullCam(result.substr(l));
-        drawCamLegend(canv, data[0], data[1]);
+        drawCamLegend(canv, data[1], data[2]);
         break;
     }
 
-    var date = new Date();
-    if (gfxtime0 != null && gfxdate0.getTime()+60000>date.getTime())
-    {
-        ctx.fillStyle = "rgba(255, 255, 255, 0.75)";
+    var now = new Date();
+    var tm  = new Date();
+    tm.setTime(data[0]);
+    if (tm.getTime()+60000<now.getTime())
+    {
+        ctx.fillStyle = "rgba(255, 255, 255, 0.85)";
         ctx.fillRect(0, 0, canv.width, canv.height);
     }