Index: trunk/FACT++/gui/FactGui.h
===================================================================
--- trunk/FACT++/gui/FactGui.h	(revision 13763)
+++ trunk/FACT++/gui/FactGui.h	(revision 13766)
@@ -7,5 +7,4 @@
 #include <valarray>
 
-#include <boost/bind.hpp>
 #include <boost/regex.hpp>
 
@@ -166,7 +165,7 @@
     {
     public:
-        boost::function<void(const QEvent &)> fFunction;
-
-        FunctionEvent(const boost::function<void(const QEvent &)> &f)
+        function<void(const QEvent &)> fFunction;
+
+        FunctionEvent(const function<void(const QEvent &)> &f)
             : QEvent((QEvent::Type)QEvent::registerEventType()),
             fFunction(f) { }
@@ -273,5 +272,5 @@
     // ===================== Services and Commands ==========================
 
-    QStandardItem *AddServiceItem(const std::string &server, const std::string &service, bool iscmd)
+    QStandardItem *AddServiceItem(const string &server, const string &service, bool iscmd)
     {
         QListView *servers     = iscmd ? fDimCmdServers     : fDimSvcServers;
@@ -350,43 +349,43 @@
     }
 
-    void AddServer(const std::string &s)
+    void AddServer(const string &s)
     {
         DimNetwork::AddServer(s);
 
         QApplication::postEvent(this,
-           new FunctionEvent(boost::bind(&FactGui::handleAddServer, this, s)));
-    }
-
-    void AddService(const std::string &server, const std::string &service, const std::string &fmt, bool iscmd)
+           new FunctionEvent(bind(&FactGui::handleAddServer, this, s)));
+    }
+
+    void AddService(const string &server, const string &service, const string &fmt, bool iscmd)
     {
         QApplication::postEvent(this,
-           new FunctionEvent(boost::bind(&FactGui::handleAddService, this, server, service, fmt, iscmd)));
-    }
-
-    void RemoveService(std::string server, std::string service, bool iscmd)
+           new FunctionEvent(bind(&FactGui::handleAddService, this, server, service, fmt, iscmd)));
+    }
+
+    void RemoveService(string server, string service, bool iscmd)
     {
         UnsubscribeService(server+'/'+service, true);
 
         QApplication::postEvent(this,
-           new FunctionEvent(boost::bind(&FactGui::handleRemoveService, this, server, service, iscmd)));
-    }
-
-    void RemoveAllServices(const std::string &server)
+           new FunctionEvent(bind(&FactGui::handleRemoveService, this, server, service, iscmd)));
+    }
+
+    void RemoveAllServices(const string &server)
     {
         UnsubscribeAllServices(server);
 
         QApplication::postEvent(this,
-           new FunctionEvent(boost::bind(&FactGui::handleRemoveAllServices, this, server)));
-    }
-
-    void AddDescription(const std::string &server, const std::string &service, const vector<Description> &vec)
+           new FunctionEvent(bind(&FactGui::handleRemoveAllServices, this, server)));
+    }
+
+    void AddDescription(const string &server, const string &service, const vector<Description> &vec)
     {
         QApplication::postEvent(this,
-           new FunctionEvent(boost::bind(&FactGui::handleAddDescription, this, server, service, vec)));
+           new FunctionEvent(bind(&FactGui::handleAddDescription, this, server, service, vec)));
     }
 
     // ======================================================================
 
-    void handleAddServer(const std::string &server)
+    void handleAddServer(const string &server)
     {
         const State s = GetState(server, GetCurrentState(server));
@@ -394,5 +393,5 @@
     }
 
-    void handleAddService(const std::string &server, const std::string &service, const std::string &/*fmt*/, bool iscmd)
+    void handleAddService(const string &server, const string &service, const string &/*fmt*/, bool iscmd)
     {
         QStandardItem *item = AddServiceItem(server, service, iscmd);
@@ -401,5 +400,5 @@
     }
 
-    void handleRemoveService(const std::string &server, const std::string &service, bool iscmd)
+    void handleRemoveService(const string &server, const string &service, bool iscmd)
     {
         QListView *servers = iscmd ? fDimCmdServers : fDimSvcServers;
@@ -424,5 +423,5 @@
     }
 
-    void handleRemoveAllServices(const std::string &server)
+    void handleRemoveAllServices(const string &server)
     {
         handleStateChanged(Time(), server, State(-2, "Offline", "No connection via DIM."));
@@ -444,5 +443,5 @@
     }
 
-    void handleAddDescription(const std::string &server, const std::string &service, const vector<Description> &vec)
+    void handleAddDescription(const string &server, const string &service, const vector<Description> &vec)
     {
         const bool iscmd = IsCommand(server, service)==true;
@@ -2606,5 +2605,5 @@
                 dat[i] -= fVecBiasVolt[entry.hv()]/fBiasOffsets[entry.hv()]*1e6;
 
-            //dat[i] /= entry.group()==0 ? 4 : 5;
+            dat[i] *= 4.5 / (entry.group() ? 5 : 4);
 
             fBiasCamA->SetEnable(i, uint16_t(ptr[entry.hv()])!=0x8000);
@@ -2622,5 +2621,5 @@
     bool fChatOnline;
 
-    void handleStateChanged(const Time &time, const std::string &server,
+    void handleStateChanged(const Time &time, const string &server,
                             const State &s)
     {
@@ -2983,10 +2982,10 @@
     }
 
-    void IndicateStateChange(const Time &time, const std::string &server)
+    void IndicateStateChange(const Time &time, const string &server)
     {
         const State s = GetState(server, GetCurrentState(server));
 
         QApplication::postEvent(this,
-           new FunctionEvent(boost::bind(&FactGui::handleStateChanged, this, time, server, s)));
+           new FunctionEvent(bind(&FactGui::handleStateChanged, this, time, server, s)));
     }
 
@@ -2994,5 +2993,5 @@
     {
         QApplication::postEvent(this,
-           new FunctionEvent(boost::bind(&FactGui::handleWrite, this, time, txt, qos)));
+           new FunctionEvent(bind(&FactGui::handleWrite, this, time, txt, qos)));
 
         return 0;
@@ -3057,5 +3056,5 @@
 
         QApplication::postEvent(this,
-                                new FunctionEvent(boost::bind(&FactGui::handleDimService, this, str)));
+                                new FunctionEvent(bind(&FactGui::handleDimService, this, str)));
     }
 
@@ -3081,5 +3080,5 @@
         //const boost::function<void()> f = boost::bind(handler, this, DimData(getInfo()));
 
-        FunctionEvent *evt = new FunctionEvent(boost::bind(&FactGui::CallInfoHandler, this, handler, DimData(getInfo())));
+        FunctionEvent *evt = new FunctionEvent(bind(&FactGui::CallInfoHandler, this, handler, DimData(getInfo())));
         // FunctionEvent *evt = new FunctionEvent(boost::bind(&FactGui::CallInfoHandler, this, f));
         // FunctionEvent *evt = new FunctionEvent(boost::bind(handler, this, DimData(getInfo()))));